Attribute VB_Name = "Module1"
Option Explicit
Dim varRegUCS2LE, strReg1 As String, strReg2 As String
Dim strRegKey As String, strRegVal As String, strVSColor As String, intRegLines As Integer
Dim strTemp As String, strSelFullPath As String, varFullPathArray

Sub InputVSColorsReg()
Dim n As Integer, WshShell As Object, uBnd As Long, mWrkbk As Workbook
Set WshShell = CreateObject("WScript.Shell")
Set mWrkbk = ThisWorkbook
' Open File Dialog
With Application.FileDialog(msoFileDialogFilePicker)
   .Filters.Add "All Files", "*.*", 1
   .Filters.Add "Registry Files", "*.reg", 2
   .FilterIndex = 2
   .AllowMultiSelect = False
   
strSelFullPath = Worksheets(1).Range("A1").Item(1, 8)
If strSelFullPath = "" Then
   .InitialFileName = WshShell.SpecialFolders("MyDocuments")
   ThisWorkbook.Sheets(1).Range("B1:B501").NumberFormat = "@"  ' Format once for Hex values
Else     ' extract path
   .InitialFileName = Left$(strSelFullPath, InStrRev(strSelFullPath, "\", -1, vbTextCompare))
End If

   If .Show = -1 Then
      strSelFullPath = .SelectedItems(1)   ' choose first item from collection
      Worksheets(1).Range("H1") = strSelFullPath
      varFullPathArray = Split(strSelFullPath, "\")
      uBnd = UBound(varFullPathArray, 1)
      Worksheets(1).Range("H2") = varFullPathArray(uBnd)
   
   Else
      GoTo 90
   End If
End With

' Load VSColors Registry File line by line
Open strSelFullPath For Input As #1
Do While Not EOF(1)
   n = n + 1
   Line Input #1, strTemp
   Select Case n
   Case 1   ' detect presence of BOM
      If Left$(strTemp, 2) = Chr(&HFF) & Chr(&HFE) Then
         varRegUCS2LE = Chr(&HFF) & Chr(&HFE)   ' detect BOM
         strReg1 = Mid$(strTemp, 3)
      Else
         strReg1 = strTemp
      End If
   Case 2
      strReg2 = strTemp
   Case 3
      strRegKey = strTemp
   Case 4   ' find Hex color data
      strRegVal = Mid$(strTemp, 1, 63)
      strVSColor = Mid$(strTemp, 64)
   Case Else
      strVSColor = strVSColor & strTemp
   End Select
Loop
Close #1

' remove extraneous characters
strVSColor = Replace(strVSColor, " ", "")
strVSColor = Replace(strVSColor, "\", "")

Dim varR, varG, varB, m As Integer, H As String
H = "&H"
m = 1
' extract color data
With ThisWorkbook.Sheets(1).Range("A1")
For n = 1 To 501  ' number of VS color keys
   varR = Mid$(strVSColor, m, 2)
   varG = Mid$(strVSColor, m + 3, 2)
   varB = Mid$(strVSColor, m + 6, 2)
   ' set cell interior color according to registry value
   .Item(n, 1).Interior.Color = RGB(H & varR, H & varG, H & varB)
   If .Interior.Color > &H7FFFFF Then
      .Characters().Font.Color = RGB(0, 0, 0)     ' set contrasting text color
   Else
      .Characters().Font.Color = RGB(255, 255, 255)
   End If
   .Item(n, 2) = StrConv(varR & varG & varB, vbUpperCase)
   m = m + 12  ' jump forward 12 i.e. RR,GG,BB,AA,RR,GG,BB,AA etc
Next n
End With

90:
End Sub

Sub OutputVSColorsReg()
Dim varR, varG, varB, n As Integer, m As Integer
Dim sColor As String, varSelFile_
Dim strVSColorUC As String
m = 1
strVSColor = ""

With ThisWorkbook.Sheets(1).Range("A1")
For n = 1 To 501  ' collecting RGB values to store in registry
   sColor = Right("000000" & Hex(.Item(n, 1).Interior.Color), 6)
   varR = Right(sColor, 2)
   varG = Mid(sColor, 3, 2)
   varB = Left(sColor, 2)
   strVSColor = strVSColor & varR & "," & varG & "," & varB & "," & "00" & ","
Next n
End With

strVSColor = StrConv(Left$(strVSColor, Len(strVSColor) - 1), vbLowerCase)  ' remove final ","

varSelFile_ = "_" & Worksheets(1).Range("H2") ' add underscore to input filename

' Format strVSColor in registry export format
strTemp = Mid$(strVSColor, 1, 15)
For n = 1 To 80
   strTemp = strTemp & "\" & vbCrLf & "  " & Mid$(strVSColor, 16 + (n - 1) * 75, 75)
Next n

' get file name for SaveAs
Dim fSaveAs, rtnMsgBox As String
50:
fSaveAs = Application.GetSaveAsFilename(varSelFile_, "Registry Files (*.reg), *.reg, All Files (*.*), *.*", 1)
If fSaveAs <> False Then         ' Cancel Button NOT clicked
   rtnMsgBox = vbYes
   If Dir(fSaveAs) <> "" Then    ' File already exists - overwrite warning
      varSelFile_ = fSaveAs
      rtnMsgBox = MsgBox("Overwrite " & fSaveAs & "?", vbYesNo, "Save file")
   End If
   Select Case rtnMsgBox
   Case vbYes
      Open fSaveAs For Output As #2
      strVSColor = "Windows Registry Editor Version 5.00" & vbCrLf & vbCrLf _
                     & "[HKEY_CURRENT_USER\Software\Microsoft\VCExpress\10.0\UseDebugColorScheme]" _
                     & vbCrLf & Chr(34) & "VSColors" & Chr(34) _
                     & "=hex:ff,00,ff,00,ff,00,ff,00,ff,00,ff,00,ff,00,ff,00," _
                     & strTemp & vbCrLf      ' final vbCrLf on exported registry file
      If varRegUCS2LE = Chr(&HFF) & Chr(&HFE) Or IsEmpty(varRegUCS2LE) Then
         strVSColorUC = StrConv(strVSColor, vbUnicode)
         Print #2, Chr(&HFF) & Chr(&HFE) & strVSColorUC;    ' trailing semicolon avoids adding VbCrLf to file!!!
         GoTo 90
      ElseIf varRegUCS2LE = "" Then
         Print #2, strVSColor;                     ' print ANSI version
      End If
   Case vbNo
      GoTo 50
   End Select
90:
ThisWorkbook.Sheets(1).Range("H4") = fSaveAs
End If
Close #2
End Sub

Function getRGB(rcell) As String    ' not currently used
Dim C As Long, R, G, b, t, n
C = rcell.Interior.Color
R = C Mod 256
G = C \ 256 Mod 256
b = C \ 65536 Mod 256
getRGB = Format(Hex(R), "00") & Format(Hex(G), "00") & Format(Hex(b), "00")

End Function

